diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-mac-rc.cc ns-3.31/src/uan/model/uan-mac-rc.cc
--- ns-3.30.1/src/uan/model/uan-mac-rc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-mac-rc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -342,7 +342,7 @@
 
       if (ch.GetDest () == Mac8Address::ConvertFrom (GetAddress ()))
         {
-          NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Node " << Mac8Address::ConvertFrom (GetAddress ()) << 
+          NS_LOG_DEBUG (Now ().As (Time::S) << " Node " << Mac8Address::ConvertFrom (GetAddress ()) << 
                         " UanMacRc Receiving DATA packet from PHY");
           UanHeaderRcData dh;
           pkt->RemoveHeader (dh);
@@ -366,14 +366,14 @@
 
         Time winDelay = ctsg.GetWindowTime ();
 
-        if (winDelay.GetSeconds () > 0)
+        if (winDelay > Time (0))
           {
             m_rtsBlocked = false;
             Simulator::Schedule (winDelay, &UanMacRc::BlockRtsing, this);
           }
         else
           {
-            NS_FATAL_ERROR (Simulator::Now ().GetSeconds () << " Node " << 
+            NS_FATAL_ERROR (Now ().As (Time::S) << " Node " << 
                             Mac8Address::ConvertFrom (GetAddress ()) << " Received window period < 0");
           }
 
@@ -395,7 +395,7 @@
                   }
                 else
                   {
-                    NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Node " << 
+                    NS_LOG_DEBUG (Now ().As (Time::S) << " Node " << 
                                   Mac8Address::ConvertFrom (GetAddress ()) << 
                                   " received CTS while state != RTSSENT or GWPING");
                   }
@@ -437,12 +437,12 @@
     }
   if (it == m_resList.end ())
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Node " << 
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Node " << 
                     Mac8Address::ConvertFrom (GetAddress ()) << 
                     " received CTS packet with no corresponding reservation!");
       return;
     }
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << 
+  NS_LOG_DEBUG (Now ().As (Time::S) << 
                 " Node " << Mac8Address::ConvertFrom (GetAddress ()) << 
                 " received CTS packet.  Scheduling data");
   it->SetTransmitted ();
@@ -481,23 +481,16 @@
 
       pkt->AddHeader (ch);
       Time eventTime = startDelay + frameDelay;
-      if (eventTime.GetSeconds () < 0)
+      if (eventTime < Time (0))
         {
-          if (eventTime.GetSeconds () > -0.001)
-            {
-              eventTime = Seconds (0);
-            }
-          else
-            {
-              NS_FATAL_ERROR ("Scheduling error resulted in very negative data transmission time! eventTime = " << eventTime.GetSeconds ());
-            }
+          NS_FATAL_ERROR ("Scheduling error resulted in very negative data transmission time! eventTime = " << eventTime.As (Time::S));
         }
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << 
+      NS_LOG_DEBUG (Now ().As (Time::S) << 
                     " Node " << Mac8Address::ConvertFrom (GetAddress ()) << 
-                    " scheduling with delay " << eventTime.GetSeconds () << 
-                    " propDelay " << m_learnedProp.GetSeconds () << 
-                    " start delay " << startDelay.GetSeconds () << 
-                    " arrival time " << arrTime.GetSeconds ());
+                    " scheduling with delay " << eventTime.As (Time::S) << 
+                    " propDelay " << m_learnedProp.As (Time::S) << 
+                    " start delay " << startDelay.As (Time::S) << 
+                    " arrival time " << arrTime.As (Time::S));
       Simulator::Schedule (eventTime, &UanMacRc::SendPacket, this, pkt, m_currentRate);
       frameDelay = frameDelay + m_sifs + Seconds (pkt->GetSize () / currentBps);
     }
@@ -545,7 +538,7 @@
       type = "UNKNOWN";
       break;
     }
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << 
+  NS_LOG_DEBUG (Now ().As (Time::S) << 
                 " Node " << Mac8Address::ConvertFrom (GetAddress ()) << 
                 " transmitting " << pkt->GetSize () << 
                 " byte packet of type " << type << " with rate " << rate << 
@@ -588,7 +581,7 @@
       uint8_t pnum = 0;
       for (; nit != nacks.end (); nit++)
         {
-          NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Node " << 
+          NS_LOG_DEBUG (Now ().As (Time::S) << " Node " << 
                         Mac8Address::ConvertFrom (GetAddress ()) << 
                         " Received NACK for " << (uint32_t) *nit);
           while (pnum < *nit)
@@ -603,7 +596,7 @@
     }
   else
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Node " << 
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Node " << 
                     Mac8Address::ConvertFrom (GetAddress ()) << 
                     " received ACK for all frames");
     }
@@ -639,7 +632,7 @@
       Ptr<Packet> pkt = Create<Packet> (0);
       pkt->AddHeader (CreateRtsHeader (res));
       pkt->AddHeader (UanHeaderCommon (Mac8Address::ConvertFrom (GetAddress ()), Mac8Address::GetBroadcast (), static_cast<uint8_t>(TYPE_GWPING), 0));
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Sending first GWPING " << *pkt);
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Sending first GWPING " << *pkt);
       SendPacket (pkt,m_currentRate + m_numRates);
     }
   m_state = GWPSENT;
@@ -754,7 +747,7 @@
 
       if (m_resList.empty ())
         {
-          NS_FATAL_ERROR (Simulator::Now ().GetSeconds () << " Node " << 
+          NS_FATAL_ERROR (Now ().As (Time::S) << " Node " << 
                           Mac8Address::ConvertFrom (GetAddress ()) << 
                           " tried to retry RTS with empty reservation list");
         }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-mac-rc-gw.cc ns-3.31/src/uan/model/uan-mac-rc-gw.cc
--- ns-3.30.1/src/uan/model/uan-mac-rc-gw.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-mac-rc-gw.cc	2020-06-27 17:38:30.000000000 -0700
@@ -226,11 +226,11 @@
         m_propDelay[ch.GetSrc ()] = dh.GetPropDelay ();
         if (m_ackData.find (ch.GetSrc ()) == m_ackData.end ())
           {
-            NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GATEWAY Received unexpected data packet");
+            NS_LOG_DEBUG (Now ().As (Time::S) << " GATEWAY Received unexpected data packet");
           }
         else
           {
-            NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW Received data packet from " << ch.GetSrc () << " length = " << pkt->GetSize ());
+            NS_LOG_DEBUG (Now ().As (Time::S) << " GW Received data packet from " << ch.GetSrc () << " length = " << pkt->GetSize ());
             m_ackData[ch.GetSrc ()].rxFrames.insert (dh.GetFrameNo ());
           }
         m_forwardUpCb (pkt, ch.GetProtocolNumber (), ch.GetSrc ());
@@ -255,7 +255,7 @@
             req.frameNo = rh.GetFrameNo ();
             req.retryNo = rh.GetRetryNo ();
             req.length = rh.GetLength ();
-            NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW storing reservation from " << ch.GetSrc () << " with length " << req.length);
+            NS_LOG_DEBUG (Now ().As (Time::S) << " GW storing reservation from " << ch.GetSrc () << " with length " << req.length);
             m_requests.insert (std::make_pair (ch.GetSrc (), req));
             std::map<Mac8Address, Time>::iterator it = m_propDelay.find (ch.GetSrc ());
             if (it == m_propDelay.end ())
@@ -291,11 +291,11 @@
 
   if (numRts)
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Simulator starting non-empty cycle");
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Simulator starting non-empty cycle");
     }
   else
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Simulator starting EMPTY cycle");
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Simulator starting EMPTY cycle");
     }
 
   // Calculate dataRate
@@ -414,8 +414,8 @@
 
       Time earliestArr = ctsTxTimeTotal + pdelay + pdelay + m_sifs;
       Time arrivalTime = std::max (earliestArr, nextEarliest);
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW: Scheduling request for prop. delay " << pdelay.GetSeconds () << " for " << (*it).second << " Earliest possible arrival=" << earliestArr.GetSeconds () << "  Next arrival time=" << nextEarliest.GetSeconds ());
-      nextEarliest = arrivalTime + Seconds (req.length * 8.0 / dataRate) + Seconds (m_sifs.GetSeconds () * req.numFrames);
+      NS_LOG_DEBUG (Now ().As (Time::S) << " GW: Scheduling request for prop. delay " << pdelay.As (Time::S) << " for " << (*it).second << " Earliest possible arrival=" << earliestArr.As (Time::S) << "  Next arrival time=" << nextEarliest.As (Time::S));
+      nextEarliest = arrivalTime + Seconds (req.length * 8.0 / dataRate) + m_sifs * req.numFrames;
 
       UanHeaderRcCts ctsh;
       ctsh.SetAddress (dest);
@@ -425,9 +425,9 @@
       ctsh.SetDelayToTx (arrivalTime);
       cts->AddHeader (ctsh);
 
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () <<
+      NS_LOG_DEBUG (Now ().As (Time::S) <<
                     " GW Scheduling reception for " << (uint32_t) req.numFrames <<
-                    " frames at " << (Simulator::Now () + arrivalTime).GetSeconds () << "  (delaytiltx of " << arrivalTime.GetSeconds () << ")  Total length is " << req.length << " with txtime " << req.length * 8 / dataRate << " seconds");
+                    " frames at " << (Simulator::Now () + arrivalTime).As (Time::S) << "  (delaytiltx of " << arrivalTime.As (Time::S) << ")  Total length is " << req.length << " with txtime " << req.length * 8 / dataRate << " seconds");
     }
 
   UanHeaderRcCtsGlobal ctsg;
@@ -460,7 +460,7 @@
 UanMacRcGw::EndCycle ()
 {
 
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW Ending cycle");
+  NS_LOG_DEBUG (Now ().As (Time::S) << " GW Ending cycle");
 
   Time nextAck = Seconds (0);
 
@@ -529,7 +529,7 @@
       type = "UNKNOWN";
       break;
     }
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW sending " << type << " packet with size " << pkt->GetSize () << " to " << ch.GetDest () << " at rate " << rate);
+  NS_LOG_DEBUG (Now ().As (Time::S) << " GW sending " << type << " packet with size " << pkt->GetSize () << " to " << ch.GetDest () << " at rate " << rate);
   m_phy->SendPacket (pkt, rate);
 }
 
@@ -710,7 +710,7 @@
           a++;
         }
     }
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " GW: Found optimum a = " << a);
+  NS_LOG_DEBUG (Now ().As (Time::S) << " GW: Found optimum a = " << a);
   return a;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-phy-dual.cc ns-3.31/src/uan/model/uan-phy-dual.cc
--- ns-3.30.1/src/uan/model/uan-phy-dual.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-phy-dual.cc	2020-06-27 17:38:30.000000000 -0700
@@ -111,7 +111,7 @@
 
   double totalIntDb = KpToDb (intKp + DbToKp (ambNoiseDb));
 
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Calculating SINR:  RxPower = " << rxPowerDb << " dB.  Number of interferers = " << arrivalList.size () << "  Interference + noise power = " << totalIntDb << " dB.  SINR = " << rxPowerDb - totalIntDb << " dB.");
+  NS_LOG_DEBUG (Now ().As (Time::S) << " Calculating SINR:  RxPower = " << rxPowerDb << " dB.  Number of interferers = " << arrivalList.size () << "  Interference + noise power = " << totalIntDb << " dB.  SINR = " << rxPowerDb - totalIntDb << " dB.");
   return rxPowerDb - totalIntDb;
 }
 
@@ -253,14 +253,14 @@
 {
   if (modeNum <= m_phy1->GetNModes () - 1)
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Sending packet on Phy1 with mode number " << modeNum);
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Sending packet on Phy1 with mode number " << modeNum);
       m_txLogger (pkt, m_phy1->GetTxPowerDb (), m_phy1->GetMode (modeNum));
       m_phy1->SendPacket (pkt, modeNum);
 
     }
   else
     {
-      NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Sending packet on Phy2 with mode number " << modeNum - m_phy1->GetNModes ());
+      NS_LOG_DEBUG (Now ().As (Time::S) << " Sending packet on Phy2 with mode number " << modeNum - m_phy1->GetNModes ());
       m_txLogger (pkt, m_phy2->GetTxPowerDb (), m_phy2->GetMode (modeNum - m_phy1->GetNModes ()));
       m_phy2->SendPacket (pkt, modeNum - m_phy1->GetNModes ());
     }
@@ -613,7 +613,7 @@
 void
 UanPhyDual::RxOkFromSubPhy (Ptr<Packet> pkt, double sinr, UanTxMode mode)
 {
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Received packet");
+  NS_LOG_DEBUG (Now ().As (Time::S) << " Received packet");
   m_recOkCb (pkt, sinr, mode);
   m_rxOkLogger (pkt, sinr, mode);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-phy-gen.cc ns-3.31/src/uan/model/uan-phy-gen.cc
--- ns-3.30.1/src/uan/model/uan-phy-gen.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-phy-gen.cc	2020-06-27 17:38:30.000000000 -0700
@@ -136,13 +136,13 @@
       NS_FATAL_ERROR ("Calculating SINR for unsupported mode type");
     }
 
-  double ts = 1.0 / mode.GetPhyRateSps ();
-  double clearingTime = (m_hops - 1.0) * ts;
-  double csp = pdp.SumTapsFromMaxNc (Seconds (0), Seconds (ts));
+  Time ts = Seconds (1.0 / mode.GetPhyRateSps ());
+  Time clearingTime = (m_hops - 1.0) * ts;
+  double csp = pdp.SumTapsFromMaxNc (Time (), ts);
 
   // Get maximum arrival offset
   double maxAmp = -1;
-  double maxTapDelay = 0.0;
+  Time maxTapDelay (0);
   UanPdp::Iterator pit = pdp.GetBegin ();
   for (; pit != pdp.GetEnd (); pit++)
     {
@@ -151,7 +151,7 @@
           maxAmp = std::abs (pit->GetAmp ());
           // Modified in order to subtract delay of first tap (maxTapDelay appears to be used later in code 
           // as delay from first reception, not from TX time)
-          maxTapDelay = pit->GetDelay ().GetSeconds () - pdp.GetTap(0).GetDelay().GetSeconds();
+          maxTapDelay = pit->GetDelay () - pdp.GetTap(0).GetDelay();
         }
     }
 
@@ -159,22 +159,22 @@
   double effRxPowerDb = rxPowerDb + KpToDb (csp);
   //It appears to be just the first elements of the sum in Parrish paper, 
   // "System Design Considerations for Undersea Networks: Link and Multiple Access Protocols", eq. 14
-  double isiUpa = DbToKp(rxPowerDb) * pdp.SumTapsFromMaxNc (Seconds (ts + clearingTime), Seconds (ts)); // added DpToKp()
+  double isiUpa = DbToKp(rxPowerDb) * pdp.SumTapsFromMaxNc (ts + clearingTime, ts); // added DpToKp()
   UanTransducer::ArrivalList::const_iterator it = arrivalList.begin ();
   double intKp = -DbToKp (effRxPowerDb);
   for (; it != arrivalList.end (); it++)
     {
       UanPdp intPdp = it->GetPdp ();
-      double tDelta = std::abs (arrTime.GetSeconds () + maxTapDelay - it->GetArrivalTime ().GetSeconds ());
+      Time tDelta = Abs (arrTime + maxTapDelay - it->GetArrivalTime ());
       // We want tDelta in terms of a single symbol (i.e. if tDelta = 7.3 symbol+clearing
       // times, the offset in terms of the arriving symbol power is
       // 0.3 symbol+clearing times.
 
-      int32_t syms = (uint32_t)( (double) tDelta / (ts + clearingTime));
+      int32_t syms = (uint32_t)(tDelta / (ts + clearingTime)).GetHigh ();
       tDelta = tDelta - syms * (ts + clearingTime);
 
       // Align to pktRx
-      if (arrTime + Seconds (maxTapDelay)  > it->GetArrivalTime ())
+      if (arrTime + maxTapDelay  > it->GetArrivalTime ())
         {
           tDelta = ts + clearingTime - tDelta;
         }
@@ -183,20 +183,20 @@
       if (tDelta < ts) // Case where there is overlap of a symbol due to interferer arriving just after desired signal
         {
           //Appears to be just the first two elements of the sum in Parrish paper, eq. 14
-          intPower += intPdp.SumTapsNc (Seconds (0), Seconds (ts - tDelta));
-          intPower += intPdp.SumTapsNc (Seconds (ts - tDelta + clearingTime),
-                                        Seconds (2 * ts - tDelta + clearingTime));
+          intPower += intPdp.SumTapsNc (Time (), ts - tDelta);
+          intPower += intPdp.SumTapsNc (ts - tDelta + clearingTime,
+                                        2 * ts - tDelta + clearingTime);
         }
       else // Account for case where there's overlap of a symbol due to interferer arriving with a tDelta of a symbol + clearing time later
         {
           // Appears to be just the first two elements of the sum in Parrish paper, eq. 14
-          Time start = Seconds (ts + clearingTime - tDelta);
-          Time end = /*start +*/ Seconds (ts); // Should only sum over portion of ts that overlaps, not entire ts
+          Time start = ts + clearingTime - tDelta;
+          Time end = /*start +*/ ts; // Should only sum over portion of ts that overlaps, not entire ts
           intPower += intPdp.SumTapsNc (start, end);
 
-          start = start + Seconds (ts + clearingTime);
+          start = start + ts + clearingTime;
           //Should only sum over portion of ts that overlaps, not entire ts
-          end = end + Seconds (ts + clearingTime); //start + Seconds (ts);
+          end = end + ts + clearingTime; //start + Seconds (ts);
           intPower += intPdp.SumTapsNc (start, end);
         }
       intKp += DbToKp (it->GetRxPowerDb ()) * intPower;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-prop-model.cc ns-3.31/src/uan/model/uan-prop-model.cc
--- ns-3.30.1/src/uan/model/uan-prop-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-prop-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -153,7 +153,7 @@
       m_taps.resize (index + 1);
     }
 
-  Time delay = Seconds (index * m_resolution.GetSeconds ());
+  Time delay = index * m_resolution;
   m_taps[index] = Tap (delay, amp);
 }
 const Tap &
@@ -208,7 +208,7 @@
       return std::complex<double> (0.0, 0.0);
     }
 
-  uint32_t numTaps =  static_cast<uint32_t> (duration.GetSeconds () / m_resolution.GetSeconds () + 0.5);
+  uint32_t numTaps =  (duration / m_resolution + 0.5).GetHigh ();
   double maxAmp = -1;
   uint32_t maxTapIndex = 0;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/model/uan-transducer-hd.cc ns-3.31/src/uan/model/uan-transducer-hd.cc
--- ns-3.30.1/src/uan/model/uan-transducer-hd.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/model/uan-transducer-hd.cc	2020-06-27 17:38:30.000000000 -0700
@@ -167,7 +167,7 @@
   m_arrivalList.push_back (arrival);
   Time txDelay = Seconds (packet->GetSize () * 8.0 / txMode.GetDataRateBps ());
   Simulator::Schedule (txDelay, &UanTransducerHd::RemoveArrival, this, arrival);
-  NS_LOG_DEBUG (Simulator::Now ().GetSeconds () << " Transducer in receive");
+  NS_LOG_DEBUG (Now ().As (Time::S) << " Transducer in receive");
   if (m_state == RX)
     {
       NS_LOG_DEBUG ("Transducer state = RX");
@@ -188,7 +188,7 @@
 {
   if (m_state == TX)
     {
-      Simulator::Remove (m_endTxEvent);
+      m_endTxEvent.Cancel ();
       src->NotifyTxDrop(packet);           // traced source netanim
     }
   else
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/uan/wscript ns-3.31/src/uan/wscript
--- ns-3.30.1/src/uan/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/uan/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -33,6 +33,13 @@
         'test/uan-test.cc',
         'test/uan-energy-model-test.cc',
         ]
+    
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        module_test.source.extend([
+        #   'test/uan-examples-test-suite.cc',
+            ])
+    
     headers = bld(features='ns3header')
     headers.module = 'uan'
     headers.source = [
